// liczydo do portw COM, tasza, 3.9.2006
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    function GetSerialPortsNumber : integer;
  end;

var
  Form1: TForm1;

implementation

{*
funkcja API GetLastError()
http://msdn.microsoft.com/library/default.asp?url=/library/en-us/debug/base/getlasterror.asp

systemowe kody bfw do numeru 499
http://msdn.microsoft.com/library/default.asp?url=/library/en-us/debug/base/system_error_codes__0-499_.asp

funkcja API CreateFile()
http://msdn.microsoft.com/library/default.asp?url=/library/en-us/fileio/fs/createfile.asp

*}

function TForm1.GetSerialPortsNumber : integer;
var
  serialDeviceName : String;
  i : integer;
  hSerialHandle : THandle;
  res : integer;
  lasterr : DWORD;
begin
  res := 0;
  for i := 1 to 10 do
  begin
    serialDeviceName := 'COM' + IntToStr( i );
    hSerialHandle := CreateFile(  pchar(serialDeviceName),
                                  GENERIC_READ or GENERIC_WRITE,
                                  0,
                                  nil,
                                  OPEN_EXISTING,
                                  FILE_FLAG_OVERLAPPED,
                                  0    );
    if hSerialHandle <> INVALID_HANDLE_VALUE then
      begin
        res := res + 1;
        Memo1.lines.add ('Port ' + serialDeviceName + ' istnieje w systemie :)' );
        CloseHandle ( hSerialHandle );
      end
    else
      begin
        lasterr := GetLastError;
        if lasterr = ERROR_ACCESS_DENIED then
          begin
            res := res + 1;
            Memo1.lines.add ('Port ' + serialDeviceName + ' istnieje, ale jest w uyciu :(' );
          end;
      end;
  end; // for
  GetSerialPortsNumber := res;
end;

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var serPortNo : integer;
begin
  serPortNo := GetSerialPortsNumber;
  Memo1.lines.add ('masz ' + IntToStr( serPortNo ) + ' portw szeregowych...')
end;

end.
 